#pragma once

#include "NPCommonUI.h"
#include <CommCtrl.h>

//class forwarding
interface INToolTip;

/**
* \group NPUIFrameLib 
* \date 2008/01/16
* \author hhd2002
* \brief {kr} CNToolTipMgr Class {/kr}
* \remark {kr} 
	 Ʈ ڵ鸵.
	̽캰 1 .
{/kr} 
*/
class NPCOMMONUI_API CNToolTipMgr
{
public:
	CNToolTipMgr();
	virtual ~CNToolTipMgr();

	//methods
	/**
	* \breif {kr} 츦 Ҹ.{/kr}
	*/
	void Close();
	/**
	* \breif {kr}  Ʈ  ٽñ׸ . {/kr}
	*/
	void Update();

	//properties
	/**
	* \breif {kr} 츦  ؼ θ ڵ ؾ  ʿ䰡 . {/kr}
	*/
	void SetParent(HWND hwndParent);
	/**
	* \breif {kr} ؽƮ . {/kr}
	*/
	void SetText(LPCTSTR szText);
	/**
	* \breif {kr}  . {/kr}
	*/
	void SetMargin(LPRECT prcMargin);
	/**
	* \breif {kr} ̱ . {/kr}
	*/
	void SetVisible(INToolTip* pToolTip, BOOL bVisible);
	/**
	* \breif {kr}   . {/kr}
	*/
	BOOL IsVisible();
	/**
	* \breif {kr}  ġ . {/kr}
	*/
	void SetPosition(LPPOINT ppt);

	//static properties
	static const int Prop_MaxTextLength = 128;

protected:
private:
	/**
	* \breif {kr}	츦 .
					lazy initialize
					 ó Ǵ  츦 ó ʱȭ .
					θڵ ̿Ͽ 츦 ,
					 θ찡 ҸǱ  . {/kr}
	*/
	BOOL _Init();

	BOOL m_bVisible;
	HWND m_hwndParent;
	HWND m_hwndToolTip;
	TCHAR m_szText[Prop_MaxTextLength];
	TOOLINFO m_Info;

	//static properties
	static int Prop_MaxTipWidth;

	INToolTip* m_pToolTipCurrent;
};

/**
 * \group NPUIFrameLib 
 * \date 2008/02/20
 * \author hhd2002
 * \brief {kr} INToolTip Class {/kr}
 * \remark {kr}  {/kr} 
 */
interface INToolTip
{
public:
	virtual ~INToolTip() {}
	/**
	* \breif {kr} ̴  . {/kr}
	*/
	virtual void SetVisible(BOOL bVisible) = 0;
	/**
	 * \breif {kr}  visible  . {/kr}
	 */
	virtual BOOL IsVisible() = 0;
};